#include <Servo.h> 
 
Servo servoleft;   // create servo object to control a servo 
Servo servoright;  // a maximum of eight servo objects can be created 

// pozitia de zero 
int zerost = 84;     //value must be increased for forward
int zerodr = 88;     //value must be decreased for forward
int v = 0;
int viteza = 0;      
int flagdr = 0;     //direction flag
int flagst = 0;
long siderelease = 0; //this temporization is neccessary for a smooth transition from side navigation routine to object detection routine
long flagrelease = 0; //time after direction flag is reset to zero
int corectie = 1;    //correction left-right - is needed because servos have not identical speed
int senzordr = 1;    // optic sensor right
int senzorst = 0;    // optic sensor left
int senzormij = 4;    // optic sensor middle
int valsenzordr = 0;
int valsenzorst = 0;
int valsenzormij = 0;
int oldvalsenzordr = 0;
int oldvalsenzorst = 0;
int oldvalsenzormij = 0;
int pinbuton = 7;      //buton on/off
int starebuton = 0;
 
void setup() 
{ 
  servoleft.attach(3);  // left servo digital 3
  servoright.attach(2); // right servo digital 2
  pinMode (pinbuton, INPUT);
  pinMode (senzorst, INPUT);
  pinMode (senzordr, INPUT);
  pinMode (senzormij, INPUT);
  
} 

void robotstop() 
{ 
  servoleft.write(zerost);              // stop both wheels 
  servoright.write(zerodr);
}

void forward(int v) 
{ 
  servoleft.write(zerost + v - corectie);              // fwd both wheels 
  servoright.write(zerodr - v - corectie);
}
 
void back(int v) 
{ 
  servoleft.write(zerost-v);              // back both wheels 
  servoright.write(zerodr+v);
} 
 
void turnleft(int v) 
{ 
  servoleft.write(zerost-v);              // right wheel fwd, left wheel back 
  servoright.write(zerodr-v);
}

void turnright(int v) 
{ 
  servoleft.write(zerost+v);              // right wheel back, left wheel fwd 
  servoright.write(zerodr+v);
}

void loop() 
{  
  robotstop();
  while(digitalRead(pinbuton) != HIGH) {} //wait for start button
  delay(1000);
  starebuton = 0;
  
  while(starebuton == 0)  //main loop
    {
     valsenzorst = analogRead(senzorst);
     valsenzordr = analogRead(senzordr);   //read sensors 
     valsenzormij = analogRead(senzormij);
     if((valsenzorst > oldvalsenzorst+5) || (valsenzorst < oldvalsenzorst-5)) oldvalsenzorst = valsenzorst;
     if((valsenzordr > oldvalsenzordr+5) || (valsenzordr < oldvalsenzordr-5)) oldvalsenzordr = valsenzordr;  //compensate input values so the robot will not oscilate too much left-right
     if((valsenzormij > oldvalsenzormij+5) || (valsenzormij < oldvalsenzormij-5)) oldvalsenzormij = valsenzormij;
     
    if((flagst==0) && (flagdr==0)) forward(10); //if no side was choose yet, move fwd
    
    if(flagst==1) //if flag left is 1 (one) - then navigate on left side
       {
        if((oldvalsenzorst > 200) && (oldvalsenzorst < 240)) 
           {
             if(oldvalsenzordr < 160) // check if is some obstacle on right side
               {
                turnright(10);       // if yes, turn right aprox. 90 deg.
                delay(800);
                valsenzorst = analogRead(senzorst);
                if((valsenzorst > oldvalsenzorst+5) || (valsenzorst < oldvalsenzorst-5)) oldvalsenzorst = valsenzorst;
               }
             forward(10);
           }
        if((oldvalsenzorst > 240) && ((millis()-siderelease)>800))
           {
            while((oldvalsenzorst > 200) && (flagst==1))
                 {
                  turnleft(6);
                  valsenzorst = analogRead(senzorst);
                  valsenzordr = analogRead(senzordr);   //citeste senzorii 
                  valsenzormij = analogRead(senzormij);
                  if((valsenzorst > oldvalsenzorst+5) || (valsenzorst < oldvalsenzorst-5)) oldvalsenzorst = valsenzorst;
                  if((valsenzordr > oldvalsenzordr+5) || (valsenzordr < oldvalsenzordr-5)) oldvalsenzordr = valsenzordr;  //compenseaza valorile pt a evita oscilatiile
                  if((valsenzormij > oldvalsenzormij+5) || (valsenzormij < oldvalsenzormij-5)) oldvalsenzormij = valsenzormij;
                  if((oldvalsenzormij <160) || (oldvalsenzordr <160))
                     {
                      turnright(10);
                      delay(800);
                      forward(10);
                      delay(100);
                     }
                  if((millis()-flagrelease)>10000) flagst=0;
                 }
            siderelease = millis();
            flagrelease = millis();
            forward(10);
            }
       }
       
     if(flagdr==1) //) //if flag right is 1 (one) - then navigate on right side
       {
        if((oldvalsenzordr > 200) && (oldvalsenzordr < 240)) 
          {
           if(oldvalsenzorst < 160) // check if is some obstacle on leftt side
             {                      // if yes, turn left aprox. 90 deg.
              turnleft(10);
              delay(800);
              valsenzordr = analogRead(senzordr);
              if((valsenzordr > oldvalsenzordr+5) || (valsenzordr < oldvalsenzordr-5)) oldvalsenzordr = valsenzordr;
             }
           forward(10);
          }
        if((oldvalsenzordr > 240) && ((millis()-siderelease)>800))
           {
            while((oldvalsenzordr > 200) && (flagdr==1))
                 {
                  turnright(6);
                  if((valsenzorst > oldvalsenzorst+5) || (valsenzorst < oldvalsenzorst-5)) oldvalsenzorst = valsenzorst;
                  if((valsenzordr > oldvalsenzordr+5) || (valsenzordr < oldvalsenzordr-5)) oldvalsenzordr = valsenzordr;  //compenseaza valorile pt a evita oscilatiile
                  if((valsenzormij > oldvalsenzormij+5) || (valsenzormij < oldvalsenzormij-5)) oldvalsenzormij = valsenzormij;
                  if((oldvalsenzormij <160) || (oldvalsenzorst <160))
                     {
                      turnleft(10);
                      delay(800);
                      forward(10);
                      delay(100);
                     }
                  if((millis()-flagrelease)>10000) flagdr=0;
                 }
            siderelease = millis();
            flagrelease = millis();
            forward(10);
            }
       }
     
    if(oldvalsenzorst < 180)       //detection for left side obstacle
        {
          if(flagdr==0) flagst = 1;
          while(oldvalsenzorst < 190)
              { 
               turnright(6);
               valsenzorst = analogRead(senzorst);
               if((valsenzorst > oldvalsenzorst+5) || (valsenzorst < oldvalsenzorst-5)) oldvalsenzorst = valsenzorst;
              }
         forward(10);
         siderelease = millis();
         flagrelease = millis();
        }
        
     if(oldvalsenzordr < 180)    // detection for right side obstacle
       {
          if(flagst==0) flagdr = 1;
          while(oldvalsenzordr < 190)
          {
           turnleft(6);
           valsenzordr = analogRead(senzordr);
           if((valsenzordr > oldvalsenzordr+5) || (valsenzordr < oldvalsenzordr-5)) oldvalsenzordr = valsenzordr;
          }
        forward(10);
        siderelease = millis();
        flagrelease = millis();
       }
        
     if(oldvalsenzormij < 170) //detection for front obstacle
        {
         if(flagst == 1)
               {
                turnright(10);
                delay(1000);
                while(oldvalsenzorst < 190)
                    { 
                     turnright(5);
                     valsenzorst = analogRead(senzorst);
                     if((valsenzorst > oldvalsenzorst+5) || (valsenzorst < oldvalsenzorst-5)) oldvalsenzorst = valsenzorst;
                    }
                 forward(10);
                }
          if(flagdr == 1)
               {
                 turnleft(10);
                 delay(1000);
                 while(oldvalsenzordr < 190)
                   {
                    turnleft(5);
                    valsenzordr = analogRead(senzordr);
                    if((valsenzordr > oldvalsenzordr+5) || (valsenzordr < oldvalsenzordr-5)) oldvalsenzordr = valsenzordr;
                   }
                 forward(10);
               }
           if((flagdr == 0) && (flagst == 0))
                {
                 turnright(10);
                 delay(1000);
                 forward(10);
                }
          }
             
     if(digitalRead(pinbuton) == HIGH) //exit main loop
        {
          starebuton = 1;
          delay(1000);
        }
    } //end main loop
}
